; some file related poor procs

read_texture:
;  in - esi ptr to texture file
;       ecx - texture file size  in bytes
   push        ebp
   mov         ebp,esp

   .i26        equ dword [ebp-4]
   .odd        equ dword [ebp-8]
   .endf       equ dword [ebp-12]
   .file_ptr   equ dword [ebp-16]
   .file_size  equ dword [ebp-20]
   .ennnnnn11  equ dword [ebp-20]
   .height     equ dword [ebp-28]
   .width      equ dword [ebp-32]
   .lh         equ dword [ebp-36]   ; lower height
   .lw         equ dword [ebp-40]   ; lower width
   .bpp        equ dword [ebp-44]
   .pal        equ dword [ebp-48]
   .begin      equ dword [ebp-52]
   .rle        equ dword [ebp-56]
   .restx      equ dword [ebp-60]
   .resty      equ dword [ebp-64]

   push    dword 26
   push    dword 0   ; odd
   lea     ebx,[esi+ecx]
   push    ebx       ; end
   push    esi       ; f ptr
   push    ecx       ; f size
   push    ecx       ; free   space
   cld
   cmp     word[esi],0x4d42  ;4d;42
   jne    .raw
 .bmp:
   mov     edi,20   ; os2
   mov     ecx,22   ; win
   cmp     byte[esi+24],0 ; is os2 version ?
   cmove   edi,ecx
   movzx   eax,word[esi+edi]
   movzx   ebx,word[esi+18]
   push    eax              ; h
   push    ebx              ; w
   mov     ecx,TEX_X
   mov     edx,TEX_Y
   cmp     eax,edx          ; TEX_Y
   cmova   eax,edx
   push    eax              ; lower h
   cmp     ebx,ecx          ; TEX_X
   cmova   ebx,ecx
   push    ebx              ; lower w

   mov     ebx,28
   mov     ecx,24
   cmp     edi,20
   cmove   ebx,ecx
   movzx   eax,byte[esi+ebx]
   push    eax  ; bpp
   cmp     eax,1

   je      .1_bit_bmp

 ;  cmp     eax,18
 ;  je      .24_bit_bmp

   ;4/8 bit bmp

   mov     ebx,794
   mov     ecx,1078
   mov     edx,54
   cmp     edi,20
   cmove   ecx,ebx   ; ecx - begin of data
   cmove   edx,.i26  ; edx - palette begin
   push    edx       ; pal
   push    ecx       ; dat begin
   mov     eax,22
   mov     ebx,30
   cmp     edx,26
   cmove   ebx,eax      ; win/os2 cause - compression
   movzx   ebx,byte[esi+ebx]
   push    ebx

   sub    esp,12
   mov    eax,TEX_X   ;.lw
   sub    eax,.width
   shl    eax,2
   mov    .restx,eax  ; if negative - .width < .lh
  @@:
   mov    eax,TEX_Y   ;.lh
   sub    eax,.height
   shl    eax,2
   mov    .resty,eax  ; if negative - .height < .lw

   mov    ebx,.width
   imul   ebx,.height

   mov    eax,.bpp
   cmp    eax,4
   je     .4_bit_bmp
   cmp    eax,24
   je     .24_bit_bmp
   cmp    eax,32
   je     .32_bit_bmp

   cmp    eax,8
   je     @f
   jmp    .end

 @@:
 ;  cmp    .rle,1
 ;  je     @f
   cmp    ebx,.file_size   ; TEXTURE_SIZE
   jnb    .end             ; prevent rle compression

  @@:
   mov    edi,texmap       ;  8 bit cause
   mov    ebx,.pal
   add    ebx,esi
   add    esi,.begin
   mov    ecx,.height
   cmp    .pal,26
   jne    .non_os2_8_bmp

  ; 8 bit os2 ver
  .bmp_8_os2_l:
   push   ecx
   mov    ecx,.width
  @@:
   xor    eax,eax
   lodsb
   lea    eax,[eax*3]
   mov    eax,[ebx+eax]
   stosd
   loop   @b
   add    edi,.restx
   pop    ecx
   loop   .bmp_8_os2_l

   jmp   .end

 .non_os2_8_bmp:
   sub  .endf,2
 ; 8 bit win
   cld
 .bmp_8_win_l:
   push   ecx
   mov    ecx,.width
 .bmp8wl2:
   xor    eax,eax
   lodsb
   shl    eax,4
   mov    eax,[ebx+eax]
   stosd
  .nxl:
   loop   .bmp8wl2
   add    edi,.restx
   pop    ecx
   loop   .bmp_8_win_l

   jmp  .end


 .1_bit_bmp:

   jmp  .end



 .4_bit_bmp:
   shr    ebx,1
   cmp    ebx,.file_size  ;TEXTURE_SIZE
   jnb    .end      ; prevent rle compression

   mov    eax,.pal
   lea    ebx,[eax+16*3]
   lea    ecx,[eax+16*4]
   cmp    byte[esi+24],0
   cmove  ebx,ecx
   mov    .begin,ebx

   mov    edi,texmap
   mov    ebx,.pal
   add    ebx,esi

   mov    .odd,0
   mov    eax,.lw
   shr    eax,1
   adc    .odd,0
   mov    ecx,.height
   cmp    byte[esi+24],0
   jne    .4_bit_bmp_os2

 .non_os2_4_bmp:
   ; 4 bit win
   add    esi,.begin
 .bmp_4_win_l:
   push   ecx
   mov    ecx,.width
  @@:
   xor    eax,eax
   lodsb
   mov    edx,eax
   and    eax,0xf
   shr    edx,8
   shl    eax,2
   shl    edx,2
   mov    eax,[ebx+eax]
   stosd
   dec    ecx
   jecxz  @f
   mov    eax,[ebx+edx]
   stosd
   loop   @b
  @@:
   add    edi,.restx
   pop    ecx
   loop   .bmp_4_win_l

   jmp    .end

  .4_bit_bmp_os2:

   add    esi,.begin
;   mov    ecx,.height
 .bmp_4_os2_l:
   push   ecx
   mov    ecx,.width
  @@:
   xor    eax,eax
   lodsb
   mov    edx,eax
   and    eax,0xf
   shr    edx,8
   lea    eax,[eax*3]
   lea    edx,[edx*3]
   mov    eax,[ebx+eax]
   stosd
   dec    ecx
   jecxz  @f
   mov    eax,[ebx+edx]
   stosd
   loop   @b
  @@:
   add    edi,.restx
   pop    ecx
   loop   .bmp_4_os2_l
   jmp  .end
 .24_bit_bmp:
   cld
   lea    ebx,[ebx*3]
   cmp    ebx,.file_size  ;TEXTURE_SIZE
   jnb    .end      ; prevent  compression

   mov     edi,texmap
   add     edi,TEX_X*TEX_Y*4
   xor     eax,eax
   mov     [edi],eax

   add     esi,.pal
   mov     ecx,.height
  .bmp_nx24_bit:
   push    ecx
   mov     ecx,.width
  .bmp_nx24_bit2:
  @@:
   cld
   lodsd
   dec     esi
   std
   stosd
   loop    @b
   sub     edi,.restx
   pop     ecx
   loop    .bmp_nx24_bit
   stosd
   jmp     .end

 .32_bit_bmp:
   mov     edi,texmap
   add     edi,TEX_X*TEX_Y*4
   add     esi,.pal
   mov     ecx,.height
 .bmp_nx32_bit:
   push    ecx
   mov     ecx,.width
  @@:
   cld
   lodsd
   std
   stosd
   loop    @b
   sub     edi,.restx
   pop     ecx
   loop    .bmp_nx32_bit

   jmp     .end

 .raw:

   mov     esi,.file_ptr ;[File_tex_ptr]
   mov     edi,texmap
   cld
   cmp     .file_size,TEX_X*TEX_Y*3
   jnae    .end
   mov     ecx,TEX_X*TEX_Y  ;eax

   xor     eax,eax
 @@:
   movsw
   movsb
   stosb
   loop  @b

 .end:
   cld
   mov    esp,ebp
   pop    ebp
ret
;========================================================
;========================================================
open_texture:
   pop_abi_regs
   mov     [ofntex.Flags],OFN_FILEMUSTEXIST+OFN_PATHMUSTEXIST+OFN_EXPLORER
   invoke  GetOpenFileName,ofntex
   or      eax,eax
   jz      .cancel
   mfree   [File_tex_ptr]
   mov     [File_tex_ptr],0
   invoke  CreateFile,fnametex,GENERIC_READ,FILE_SHARE_READ,0,OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL,0
   mov     [hfiletex],eax
   cmp     eax,-1
   je      .failed
   invoke  GetFileSize,[hfiletex],0
   cmp     eax,-1
   je      .failed
   mov     [FileSize],eax

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; read raw file
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;  mov      ebx,eax
   add      eax,4000
   malloc   eax
 .read_file:      ; read texture
   mov     [File_tex_ptr],eax
   invoke  ReadFile,[hfiletex],eax,[FileSize],BytesRead,0
   or      eax,eax
   jz      .read_error
   invoke  CloseHandle,[hfiletex]
   mov     [hfiletex],0

;   mov     esi,[File_tex_ptr]
  .init_ptr:
   invoke  InvalidateRect,[hwnd],0,1
   xor     eax,eax
   jmp     .return
   ret

 .read_error:
   mfree   [File_tex_ptr]
   mov     [File_tex_ptr],0
 .failed:
   cmp     [hfiletex],0
   je      @f
   invoke  CloseHandle,[hfiletex]
  @@:
   mov     [FileSize],0
   invoke  MessageBox,[hwnd],_notraw,0,MB_OK
  .cancel:
  .return:
   push_abi_regs
ret


;===============================================================================

save_fileA:
; in:
;    edx - buffer to save
;    eax - file_name (aciiz)
;    ecx - data size in bytes
    push      ebp
    mov       ebp,esp
    sub       esp,4
   .file_handle equ dword[ebp-4]
    push      edx ecx
    invoke    CreateFile,eax,GENERIC_WRITE, 0, 0,CREATE_ALWAYS, FILE_ATTRIBUTE_NORMAL, 0
    pop       ecx edx
    mov       .file_handle,eax
    invoke    WriteFile,.file_handle ,edx,ecx,byteswritten, 0
    invoke    CloseHandle,.file_handle

    mov       esp,ebp
    pop       ebp
ret

;==============================================================================
save_chunks_file:

    push      ebp
    mov       ebp,esp
    .size1    equ [ebp-4]
    .size2    equ [ebp-8]
    .buff     equ [ebp-12]
    mov       ecx,[triangles_count_var]
    add       ecx,ecx
    push      ecx                     ; siz1
    mov       eax,[chunks_count]
    shl       eax,4
    add       eax,ecx
    push      eax                     ; siz2
    add       eax,70
    malloc    eax
    push      eax                     ; buff
    mov       esi,[chunks_ptr]
    mov       edi,eax
    mov       ecx,.size1
    shr       ecx,2
    inc       ecx
    cld
    rep       movsd
    mov       edi,.buff
    add       edi,.size1
    mov       esi,[chunks_desc_ptr]
    mov       ecx,[chunks_count]
    shl       ecx,2
    rep       movsd
    mov       edx,.buff   ;[chunks_ptr]
    or        edx,edx
    jz        .ff
    mov       eax,Chfile_name
    mov       ecx,.size2  ;[triangles_count_var]
    call      save_fileA
  .ff:
    mfree     .buff
    mov       esp,ebp
    pop       ebp
    ret
;===================================================================================

save3ds:
   pushad
   mov    ebp,esp
   sub    esp,20

   .3dbuffer_ptr  equ [ebp-4]
   .file_handle   equ [ebp-8]
   .bytes_written equ [ebp-12]
   .file_size     equ [ebp-16]
   .acc           equ dword[ebp-20]

    mov     eax,[points_count_var]
    add     eax,[triangles_count_var] ; to big mem, I know
    add     eax,100
    imul    eax,12
    malloc  eax
    mov    .3dbuffer_ptr,eax

    mov   edx,[triangles_count_var]
    mov   ecx,[points_count_var]
 ;   cmp   edx,ecx
 ;   cmovb edx,ecx
    cmp   edx,65535     ; above 65535 elements  ???
    ja    .chu          ; so - old routines
    cmp   ecx,65535
    ja    .chu


    mov   edi,eax
    mov   [edi],word 4d4dh
    add   edi,6
    mov   [edi],word 3d3dh
    add   edi,6
    mov   [edi],word 4000h
    add   edi,6
    mov   [edi],byte 0
    inc   edi
    mov   [edi],word 4100h     ;    [global_points_counter]
    add   edi,6
    mov   [edi],word 4110h
 ;   mov   ecx,[points_count_var]

    mov   edx,ecx
    mov   [edi+6],cx
    add   edi,8
    mov   esi,[points_rotated_ptr];   [points_r_ptr]   ;
    xor   ebx,ebx
    lea   ecx,[ecx*3]
    cld
  @@:
    rep   movsd
    mov   [edi],word 4120h
    mov   ecx,[triangles_count_var]
    mov   [edi+6],cx
    add   edi,8
    mov   esi,[triangles_ptr]
    cld
  @@:
    movups    xmm0,[esi]
    packssdw  xmm0,xmm0
    movq      [edi],xmm0
    mov       dword[edi+6],0
    add       esi,12
    add       edi,8
    loop      @b
    jmp       .wrt
.chu:
    mov   ebx,[chunks_desc_ptr]
    cld
    mov   edi,eax
    mov   [edi],word 4d4dh
    add   edi,6
    mov   [edi],word 3d3dh
    add   edi,6
    xor   eax,eax
    mov   .acc,eax   ; tri acc
 ;   add   ebx,16
    xor   ecx,ecx
   .4k:
    push  ecx
    mov   [edi],word 4000h
    add   edi,6
    mov   [edi],byte 0
    inc   edi
    mov   [edi],word 4100h     ;    [global_points_counter]
    add   edi,6
    mov   [edi],word 4110h
  ; mov   ecx,[points_count_var]
  ; mov   edx,ecx

  ; mov    [edi+6],cx
    mov   ecx,[ebx+4]
    mov   [edi+6],cx      ; vert cnt
    add   edi,8
    mov   esi,[ebx+8]
 ;  inc   esi
    imul  esi,12
    add   esi,[points_rotated_ptr]
 ;  add   esi,[ebx+8] ; vert ofs
 ;  xor   ebx,ebx
    lea   ecx,[ecx*3]
  @@:
    rep    movsd
    mov    [edi],word 4120h
    mov    ecx,[ebx]
  ;  inc    ecx
    pop    edx
    add    ecx,edx
    mov    [edi+6],cx
    add    edi,8
    mov    esi,[ebx+12]
    inc    esi
    imul   esi,12
    add    esi,[triangles_ptr]
  ;  add    esi,[ebx+12]          ; tri ofset
    cld
    movss    xmm2,.acc
    shufps   xmm2,xmm2,0
  @@:
    movups    xmm0,[esi]
    psubd     xmm0,xmm2
    packusdw  xmm0,xmm0
    movq      [edi],xmm0
    mov       word[edi+6],0
    add       esi,12
    add       edi,8
    loop      @b
    mov       ecx,[ebx+4]  ; vert cnt
    add       .acc,ecx
    add       ebx,16
    mov       ecx,edx
    inc       ecx
;    cmp       ecx,[chunks_count]
;    jne       .4k
    cmp       dword[ebx],0
    jne       .4k

  .wrt:
    mov       ebx,.3dbuffer_ptr
    sub       edi,.3dbuffer_ptr
    mov       [ebx+2],edi
    mov       .file_size,edi
    mov       ecx,edi
    lea       edx,[ebx]
    mov       eax,Bfile_name
    call      save_fileA
    mfree     .3dbuffer_ptr
    mov       esp,ebp
    popad
ret
;==============================================================================

open_file:    ; asc or 3ds

   mov     [ofn.Flags],OFN_FILEMUSTEXIST+OFN_PATHMUSTEXIST+OFN_EXPLORER
   invoke  GetOpenFileName,ofn
   or      eax,eax
   jz      .cancel

   invoke  CreateFile,fname,GENERIC_READ,FILE_SHARE_READ,0,OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL,0
   mov     [hfile],eax
   cmp     eax,-1
   je      .failed
   invoke  GetFileSize,[hfile],0
   cmp     eax,-1
   je      .failed
   mov     [FileSize],eax
   malloc  eax
   mov     [File_ptr],eax
   invoke  ReadFile,[hfile],eax,[FileSize],BytesRead,0
   or      eax,eax
   jz      .read_error
   invoke  CloseHandle,[hfile]
   mov     [hfile],0

   mov     eax,[BytesRead]
   mov     ebx,[File_ptr]
   mov     cx,WORD [ebx]
   cmp     cx,'MM'
   je      @f
   mov     [file_ext_flag],1  ; asc
   jmp     .init_ptr
 @@:
   mov     [file_ext_flag],0
 .init_ptr:
   invoke  InvalidateRect,[hwnd],0,1
   xor     eax,eax
   ret
 .read_error:
 .failed:  ; always crash if not aprporiate file
           ; think about generating object ....
   cmp     [hfile],0
   je      @f
   invoke  CloseHandle,[hfile]
  @@:
   invoke  MessageBox,[hwnd],_not3ds,0,MB_OK
  .cancel:
   invoke  ReleaseDC,[hwnd],[hdc]
   invoke  DestroyWindow,[hwnd]
   invoke  ExitProcess,[msg.wParam]

ret


;=========================================================================
;=========================================================================

open_next_mesh:
  ; in - eax = 0  ->  join to existing mesh, otherwise load new mesh
  ;
  ; allocate mem, open from file and join to existing object  if eax=0
  ; out - eax - points count    of new mesh
  ;       ebx - triangles count of new mesh

  push  ebp
  mov   ebp,esp
  sub   esp,76

  .FileSize      equ  [ebp-4]
  .hfile         equ  [ebp-8]
  .pmem          equ  [ebp-12]
  .file_ptr      equ  [ebp-16]
  .BytesRead     equ  [ebp-20]
  .file_ext_flag equ  [ebp-24]
  .points_count  equ  [ebp-28]
  .tri_count     equ  [ebp-32]
  .vertices_ptr  equ  [ebp-36]
  .tri_ptr       equ  [ebp-40]
  .JoinNew       equ  [ebp-44]
  .hheap         equ  [ebp-48]
  .BytesRead     equ  [ebp-52]
  .NMmem         equ  [ebp-56]
  .new_tri_offset   equ  [ebp-60]
  .new_vert_offset  equ  [ebp-64]
  .new_tri_number   equ  [ebp-68]
  .new_vert_number  equ  [ebp-72]

      mov        .JoinNew,eax
      xor        edx,edx
      mov        .points_count,edx
      mov        .tri_count,edx
      mov        [ofn.Flags],OFN_FILEMUSTEXIST+OFN_PATHMUSTEXIST+OFN_EXPLORER
      invoke     GetOpenFileName,ofn
      or         eax,eax
      jz         .end
      invoke     CreateFile,fname,GENERIC_READ,FILE_SHARE_READ,0,OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL,0
      mov        [hfile],eax
      cmp        eax,-1
      je         .failed
      invoke     GetFileSize,[hfile],0
      cmp        eax,-1
      je         .failed
      mov        [FileSize],eax
      malloc     eax
      mov        [File_ptr],eax
      invoke     ReadFile,[hfile],eax,[FileSize],BytesRead,0
      or         eax,eax
      jz         .read_error


      mov        ebx,hfile
      invoke     CloseHandle,[ebx]
      xor        eax,eax
      mov        [ebx],eax
      mov        ebx,[FileSize]   ;.BytesRead   ;.FileSize
      mov        eax,[File_ptr]   ;[NMmem]
      xor        edx,edx          ; no read chunks
      call       read_tp_variables1
      mov        .points_count,ecx
      mov        .tri_count,ebx
      xor        eax,eax
      cmp        byte .JoinNew,'m'  ; join to existing object
      je         @f                  ; or load diffrent?
      mov        [points_count_var],eax
      mov        [triangles_count_var],eax
   @@:
     ;alloc     mem to new and old vertices   and new and old triangles lists
      mov        eax,dword .points_count
      mov        ebx,[points_count_var]
      add        eax,ebx
      imul       eax,12
      add        eax,20
      malloc     eax
      mov        .vertices_ptr,eax
      mov        .new_vert_offset,eax
      mov        eax,dword .tri_count
      mov        ebx,[triangles_count_var]
      add        eax,ebx
      add        eax,1000
      imul       eax,12
      malloc     eax
      mov        .tri_ptr,eax
      mov        .new_tri_offset,eax


      cmp     byte .JoinNew,'n'
      je      .nocopy
      ;copy old    to new lists
      mov     edi,.tri_ptr
      mov     esi,[triangles_ptr]
      mov     ecx,[triangles_count_var]
      cld
      lea     ecx,[ecx*3]
      rep     movsd
      mov     .new_tri_offset,edi

      mov     edi,.vertices_ptr
      mov     esi,[points_r_ptr]
      mov     ecx,[points_count_var]
      lea     ecx,[ecx*3]
      rep     movsd
      mov     .new_vert_offset,edi

      ;stack 1 - vertices count to normalise
      ;stack 2 - pointer to vertices
      push    dword .vertices_ptr
      push    [points_count_var]
      call    normalize_object1
   .nocopy:
     ;read from second file
      mov     eax,.new_tri_offset
      mov     ebx,.new_vert_offset
      mov     ecx,[File_ptr]
      mov     edx,ecx
      add     edx,[FileSize]

      ; read from 3ds file
      ;in:  eax - ptr to triangles
      ;     ebx - ptr to vertices
      ;     ecx - ptr to file begin
      ;     edx - ptr to file end
      ;out: ecx - points (vertices) count
      ;     edx - triangles count

      call    read_from_file
      mov     .new_vert_number,ecx
      mov     .new_tri_number,edx
      ;stack 1 - vertices count to normalise
      ;stack 2 - pointer to vertices
      push    dword .new_vert_offset
      push    ecx
      call    normalize_object1
      cmp     byte .JoinNew,'n'
      je      .no_fix
      ;fix triangles list
      mov     ebx,.new_tri_offset
      mov     eax,[points_count_var] ;.new_vert_number
      mov     ecx,.new_tri_number
      lea     ecx,[ecx*3]
  @@:
      add     dword[ebx],eax
      add     ebx,4
      loop    @b
   .no_fix:
      mov     eax,.new_vert_number
      mov     ebx,.new_tri_number
      add     [points_count_var],eax
      add     [triangles_count_var],ebx
      xor     eax,eax
      call    free_mem_for_tp   ; release all buffers mem
      xor     eax,eax
      call    alloc_mem_for_tp1 ; alloc all but triangles_ptr, points_r_ptr
      mfree   [triangles_ptr]
      mfree   [points_r_ptr]
      push    dword .vertices_ptr
      pop     [points_r_ptr]
      push    dword .tri_ptr
      pop     [triangles_ptr]
   ;   mov     ebx,hfile
   ;   invoke  CloseHandle,[ebx]
   ;   xor     eax,eax
   ;   mov     [ebx],eax
   .init_ptr:
      invoke  InvalidateRect,[hwnd],0,1
      jmp     .end
   .read_error:
   .failed:  ; always crash if not apropriate file
              ; think about generating object ....
      xor     ebx,ebx
      mov     eax,hfile
      cmp     dword[eax],ebx
      je      .end
      invoke  CloseHandle,[eax]
   .end:
      mov     eax,.new_vert_number
      mov     ebx,.new_tri_number
      mov     esp,ebp
      pop     ebp
ret





