
; Thanks to Reverend for integer/float/ascii conversion examples

read_asc_tp_variables:
    mov  eax,[File_ptr]
 .find_vert:
    cmp  dword[eax],'Vert'
    je	 @f
    inc  eax
    jmp  .find_vert
  @@:
    add   eax,4
    cmp   dword[eax],'ices'
    jne   .find_vert
    add   eax,3
  @@:
    inc   eax
    cmp   byte[eax],'0' 	  ; search end of ascii number of vertices string
    jb	  @b
    cmp   byte[eax],'9'
    ja	  @b
;    eax - start ascii number
  @@:
    inc    eax
    cmp    byte[eax],'0'
    jb	  .convert1
    cmp    byte[eax],'9'
    ja	  .convert1
    jmp   @b
  .convert1:
    dec   eax
    mov   ebx,eax
    push  eax
    call  ascii_to_integer
    mov   [points_count_var],edx
    pop   eax

  @@:
    inc   eax
    cmp   dword[eax],'Face'
    jne   @b
    add   eax,3
  @@:
    inc   eax
    cmp   byte[eax],'0'
    jb	  @b
    cmp   byte[eax],'9'
    ja	  @b
   ;	eax - start ascii number
  @@:
    inc    eax
    cmp    byte[eax],'0'
    jb	  .convert2
    cmp    byte[eax],'9'
    ja	  .convert2
    jmp   @b
   ;  eax - end ascii number
  .convert2:
    dec   eax
    mov   ebx,eax
    push  eax
    call  ascii_to_integer
    mov   [triangles_count_var],edx
    pop   eax
ret

read_asc:
    mov  eax,[File_ptr]
 .find_vert:
    cmp  dword[eax],'Vert'
    je	 @f
    inc  eax
    jmp  .find_vert
  @@:
    add   eax,4
    cmp   dword[eax],'ices'
    jne   .find_vert
    add   eax,3
  @@:
    inc   eax
    cmp   byte[eax],'0' 	  ; search end of ascii number of vertices string
    jb	  @b
    cmp   byte[eax],'9'
    ja	  @b
;    eax - start ascii number
  @@:
    inc    eax
    cmp    byte[eax],'0'
    jb	  .convert1
    cmp    byte[eax],'9'
    ja	  .convert1
    jmp   @b
  .convert1:
    dec   eax
    mov   ebx,eax
    push  eax
    call  ascii_to_integer
    mov   [points_count_var],edx
    pop   eax

  @@:
    inc   eax
    cmp   dword[eax],'Face'
    jne   @b
    add   eax,3
  @@:
    inc   eax
    cmp   byte[eax],'0'
    jb	  @b
    cmp   byte[eax],'9'
    ja	  @b
   ;	eax - start ascii number
  @@:
    inc    eax
    cmp    byte[eax],'0'
    jb	  .convert2
    cmp    byte[eax],'9'
    ja	  .convert2
    jmp   @b
   ;  eax - end ascii number
  .convert2:
    dec   eax
    mov   ebx,eax
    push  eax
    call  ascii_to_integer
    mov   [triangles_count_var],edx
    pop   eax

  @@:
    inc   eax
    cmp   dword[eax],'Vert'
    jnz   @b
    inc   eax

    mov   edi,[points_r_ptr]
    xor   ebx,ebx
   .decode_vertices:
    push   ebx
  @@:
    inc   eax
    cmp   dword[eax],'Vert'
    jne   @b
    xor   ecx,ecx

  .decode_coord:
    push  ecx
  @@:
    inc   eax
    mov   dl,byte[eax]
    cmp   dl,byte[XYZpartices+ecx]
    jne   @b
  @@:
    inc   eax
    cmp   byte[eax],'.'
    je	  .readF
    cmp   byte[eax],'-'
    je	  .readF
    cmp   byte[eax],'0'
    jb	  @b
    cmp   byte[eax],'9'
    ja	  @b
.readF: ; read float
    mov   esi,eax
    push  eax
    push  ecx

    stdcall    atof   ; st0 - desired dword float

    pop   ecx
    pop   eax

    fstp  dword[edi]
    add   edi,4

    pop   ecx
    inc   ecx
    cmp   ecx,3
    jne   .decode_coord
    pop   ebx
    inc   ebx
    cmp   ebx,[points_count_var]
    jne   .decode_vertices
    mov   dword[edi],-1



    mov   esi,eax
   @@:
    inc   esi
    cmp   dword[esi],'Face'
    jne   @b
    xor   edx,edx
    mov   edi,[triangles_ptr]
    cld
 .decode_face:

    push  edx
   @@:
    inc   esi
    cmp   dword[esi],'Face'
    jne   @b
 @@:
    inc   esi
    cmp   byte[esi],'0'    ; face number start
    jb	  @b
    cmp   byte[esi],'9'
    ja	  @b
  @@:
    inc    esi
    cmp    byte[esi],'0'
    jb	  @f
    cmp    byte[esi],'9'   ; face number end
    ja	  @f
    jmp   @b
  @@:
    xor ecx,ecx
 .next_vertex_number:

    push  ecx
  @@:
    inc   esi
    cmp   byte[esi],'0'
    jb	  @b
    cmp   byte[esi],'9'
    ja	  @b
    ;	 eax - start ascii number
  @@:
    inc    esi
    cmp    byte[esi],'0'
    jb	  @f
    cmp    byte[esi],'9'
    ja	  @f
    jmp   @b
   ;  eax - end ascii number
  @@:
    dec   esi
    mov   ebx,esi
    push  esi
    call  ascii_to_integer
    mov   eax,edx

    stosd
    pop   esi
    add   esi,2

    pop   ecx
    inc   ecx
    cmp   ecx,3
    jne   .next_vertex_number
    pop   edx
    inc   edx
    cmp   edx,[triangles_count_var]
    jne   .decode_face
    mov   dword[edi],-1 ;dword[triangles+ebx+2],-1   ; end mark
ret
;=====================================================================
ascii_to_integer:
; in ---  [ebx] -> end of ascii string
; out --  edx  -> desired number

    xor    edx,edx
    xor    ecx,ecx
  .again:
    movzx  eax,byte[ebx]
    sub    al,'0'
    cwde
    push   edx
    mul    dword[convert_muler+ecx]
    pop    edx
    add    edx,eax
    dec    ebx
    cmp    byte[ebx],'0'
    jb	   .end
    cmp    byte[ebx],'9'
    ja	   .end
    add    ecx,4
    jmp    .again
  @@:

  .end:
ret

;===============================================================================
;	ASCII to float conversion procedure
;
;	input:
;	esi - pointer to string
;
;	output:
;	st0 - number changed into float
;	Reverend - thanks for effort!!
;===============================================================================
proc	atof
	local	.string  dd  ?
	push	eax ecx esi
	mov	[.string],esi
	fninit
	fldz
	fldz

	cld
	cmp	byte [esi], '-'
	jnz	@F
	inc	esi
    @@:
	xor	eax, eax
	align	4
  .loop.integer_part:
	lodsb
	cmp	al, '.'
	jz	.mantisa
	cmp	al,'0'
	jb	.exit
	cmp	al,'9'
	ja	.exit
	fimul	[i10]
	sub	al, '0'
	push	eax
	fiadd	dword [esp]
	add	esp, 4
	jmp	.loop.integer_part

  .mantisa:
	xor	 ecx, ecx
	xor	 eax, eax
	cld
	fxch	 st1
     @@:

	lodsb
	cmp	al,'0'
	jb	.exit
	cmp	al,'9'
	ja	.exit
	cmp	ecx,7*4
	je	.exit		; max 7 digits in mantisa
	sub	al,'0'
	push	eax
	fild	dword[esp]
	fidiv	dword[convert_muler+4+ecx]
	faddp
	add	esp,4
	add	ecx,4
	jmp	@b
  .exit:
	faddp

	mov	eax, [.string]
	cmp	byte [eax], '-'
	jnz	@F
	fchs
    @@:
	cld
	stc				; always returns no error
	pop	esi ecx eax
	ret

endp
;==============================================================================
itoa:		   ; unsigned dword integer to ascii procedure
;     in   eax - variable
;	   esi - Pointer to ascii string
;   out    esi - desired ascii string
;	   edi - end of ascii string  - ptr to memory
 .temp_string  equ dword[ebp-36]
 .ptr	       equ dword[ebp-40]
 .var	       equ dword[ebp-44]
	   push  ecx
	   push  ebp
	   mov	 ebp,esp
	   sub	 esp,64
	   mov	 .var,eax
	   or	 eax,-1
	   lea	 edi,.temp_string
	   cld
	   mov	 ecx,9
	   rep	 stosd	    ; make floor


	   mov	 .ptr,esi
	   lea	 edi,.temp_string
	   add	 edi,34
	   std
	   xor	 eax,eax
	   stosb	       ; mark begin
	   mov	 eax,.var
	   mov	 esi,10
	@@:
	   xor	 edx,edx
	   div	 esi
	   xchg  eax,edx
	   add	 al,'0'
	   stosb
	   xchg  eax,edx
	   or	 eax,eax
	   jnz	 @b
	   stosb		     ; mark end

	   lea	 esi,.temp_string
	   cld
	@@:
	   lodsb
	   or	al,al
	   jnz	@b

	   mov	edi,.ptr
	 @@:
	   lodsb
	   stosb
	   or	al,al
	   jnz	@b

	   mov	esp,ebp
	   pop	ebp
	   pop	ecx
ret
;=================================================================

ftoa:
;   in	:  esi - pointer to  dword float
;	   edi - pointer to ascii string
;	   ecx - max digits in fraction
  .ptr_f     equ dword[ebp-4]
  .sign      equ dword[ebp-8]	;  0 ->   less than zero, 1 - otherwise
  .ptr_ascii equ dword[ebp-12]
  .integer   equ dword[ebp-20]
  .fraction  equ dword[ebp-28]
  .status_orginal equ  word[ebp-32]
  .status_changed equ  word[ebp-34]
  .max_dig	  equ dword[ebp-38]

	 push	  ecx
	 push	  ebp
	 mov	  ebp,esp
	 sub	  esp,64

	mov	 .max_dig,ecx
	fninit
	fnstcw	 .status_orginal
	mov	 ax, .status_orginal
	or	 ax, 0000110000000000b
	mov	 .status_changed, ax
	fldcw	 .status_changed
;	--------------------------------
;	check if signed
	xor	 eax, eax
	fld	 dword[esi]
	fst	 .sign
	test	 .sign, 80000000h
	setz	 al
	mov	 .sign, eax
	or	 eax,eax
	jnz	 @f
	inc	 edi
       @@:

	 mov	   .ptr_f,esi
	 mov	   .ptr_ascii,edi
	 fabs
	 fld	   st0
	 frndint
	 fist	   .integer
	 fsubp	   st1, st0

	 mov	   eax,.integer
	 mov	   esi,.ptr_ascii
	 call	   itoa
      ;  edi   ->   ptr to end of ascii string
	 dec	   edi
	 mov	   al,'.'
	 stosb

	mov	ecx,.max_dig  ; max 6 digits in fraction part
    .loop:
	fimul	[i10]
	fld	st0
	frndint
	fist	.fraction
	fsubp	st1, st0
	mov	esi,edi
	mov	eax,.fraction
	add	al,'0'
	stosb
	ftst
	fnstsw	ax
	test	ax, 0100000000000000b
	jz	@F
	test	ax, 0000010100000000b
	jz	.finish
    @@:
	loop	.loop
 .finish:
	 ffree st
	 cmp	   .sign,0
	 jnz	   @f
	 mov	   esi,.ptr_ascii
	 dec	   esi
	 mov	   byte[esi],'-'
       @@:
	 mov	   esp,ebp
	 pop	   ebp
	 pop	   ecx

ret




;======================================================================

;=======================================================================
