; files routines
; asc: save, stl: save, ply: save
;======================================================================
;================================================================
write_stl:
  ; .counter	equ  dword[ebp-4]
    .file_buff	equ  dword[ebp-8]

	push  ebp
	mov   ebp,esp
	sub   esp,8

	mov	    ebx,[triangles_count_var]	;
	imul	    ebx,50
	add	    ebx,2000
	malloc	    ebx
	mov	    .file_buff,eax

	mov	    edi,eax
	mov	    eax,3
	cvtsi2ss    xmm2,eax
	shufps	    xmm2,xmm2,0
	cld
	mov	    eax,'mac '
	stosd
	add	    edi,76
	mov	    ecx,[triangles_count_var]
	mov	    eax,ecx
	stosd
	mov	    ebx,[triangles_normals_ptr]
	mov	    esi,[triangles_ptr]
      .lab_off:
	push	    ecx
	xchg	    esi,ebx
	movsd
	movsd
	movsd
	xchg	    esi,ebx
	mov	    ecx,3
      .bbb:
	lodsd
	imul	    eax,12
	add	    eax,[points_r_ptr]
	movups	    xmm0,[eax]
	addps	    xmm0,xmm2
	movups	    [edi],xmm0
	add	    edi,12
	loop	    .bbb
	add	    edi,2
	pop	    ecx
	loop	    .lab_off
	; write file
	sub	edi,.file_buff
	mov	ecx,edi
	mov	eax,stl_file_name
	mov	edx,.file_buff
	call	save_fileA
	mfree	.file_buff
	mov	esp,ebp
	pop	ebp
ret
;================================================================
write_ply:

    .pppl	equ  dword[ebp-4]
    .file_buff	equ  dword[ebp-8]
    .tcv	equ  dword[ebp-12]
    .pccv	equ  dword[ebp-16]

       push    ebp
       mov     ebp,esp
       sub     esp,20
       mov     ebx,[triangles_count_var]
       add     edx,[points_count_var]
       mov     .tcv,ebx
       mov     .pccv,edx
       imul    ebx,13
       add     ebx,600
       imul    edx,12
       add     ebx,edx
       malloc  ebx
       mov     .file_buff,eax
       cld
       mov     esi,ply_header
       mov     edi,.file_buff
      @@:
       lodsb
       cmp     al,'#'
       je      @f
       stosb
       jmp     @b
     @@:
       mov     eax,.pccv ;[points_count_var]
       push    esi
       mov     esi,edi
       call    itoa
    ;	mov    esi,edi
       dec     edi
       pop     esi
       cld
     @@:
       lodsb
       cmp     al,'#'
       je      @f
       stosb
       jmp     @b
     @@:
       mov     eax,.tcv  ;[triangles_count_var]
       push    esi
       mov     esi,edi
       call    itoa
       dec     edi
    ;	mov    esi,edi
       pop     esi
       cld
     @@:
       lodsb
       cmp     al,'#'
       je      @f
       stosb
       jmp     @b
     @@:
       mov     esi,[points_r_ptr]
       mov     ecx,.pccv ;[points_count_var]
       lea     ecx,[ecx*3]
       cld
       rep     movsd
       mov     esi,[triangles_ptr]
       mov     ecx,.tcv  ;[triangles_count_var]
       mov     al,3
      @@:
       stosb
       movsd
       movsd
       movsd
       loop    @b
       mov    edx,.file_buff
       sub    edi,edx
       mov    eax,ply_file_name
       mov    ecx,edi
       call   save_fileA
       mfree  .file_buff
       mov    esp,ebp
       pop    ebp
ret
;=================================================================================
write_asc:

    .counter	equ  dword[ebp-4]
    .file_buff	equ  dword[ebp-8]
    .pccv	equ  dword[ebp-12]
    .tccv	equ  dword[ebp-16]

	push	ebp
	mov	ebp,esp
	sub	esp,64
	mov	eax,[points_count_var]	    ;	-
	mov	.pccv,eax
	shl	eax,6			    ;	Calc
	mov	ebx,[triangles_count_var]   ;	aproximate
	mov	.tccv,ebx
	shl	ebx,5			    ;	size of
	lea	ebx,[ebx*3]		    ;	asc file
	add	eax,ebx 		    ;	buffer.
	add	eax,65536
	malloc	eax  ;	 -
	mov	.file_buff,eax

	fninit
	mov	edi,eax  ;.file_buff;asc_file_buffer
	mov	esi,asc_main_header
	cld
      @@:
	lodsb
	cmp	al,1
	jz	@f
	stosb
	jmp	@b
      @@:
	mov	esi,asc_info_header
      @@:
	lodsb
	cmp	al,1
	jz	@f
	stosb
	jmp	@b
     @@:
	push	esi  ; -> position in header info
	mov	eax,.pccv  ;[points_count_var]
	mov	esi,edi
	call	itoa		  ; unsigned dword integer to ascii procedure
	pop	esi
	inc	esi
      @@:
	lodsb
	cmp	al,1
	jz	@f
	stosb
	jmp	@b
      @@:
	push	esi
	mov	eax,.tccv   ;[triangles_count_var]
	mov	esi,edi
	call	itoa
	pop	esi
	inc	esi
      @@:
	lodsb
	cmp	al,1
	jz	@f
	stosb
	jmp	@b
      @@:
;=============================================================
;================vertex list parser===========================
;=============================================================

       xor   ecx,ecx
     .again_vertex:
       push  ecx
       mov   esi,asc_one_vertex_formula
     @@:
       lodsb
       cmp   al,1
       jz    @f
       stosb
       jmp   @b
     @@:
       mov   eax,ecx
 ;	push  ecx
       push  esi
       mov   esi,edi
       call  itoa
       pop   esi
;	pop   ecx
       inc   esi
       xor   ebx,ebx
    .next_vertex_coef:
       push  ebx
     @@:
       lodsb
       cmp   al,1
       jz    @f
       stosb
       jmp   @b
     @@:
       push  esi ecx
       lea   esi,[ecx*3]
       shl   esi,2
       add   esi,[points_r_ptr]
       add   esi,ebx
       mov   ecx,7
       call  ftoa
       pop   ecx esi
       pop   ebx
       add   ebx,4
       cmp   ebx,12
       jnz   .next_vertex_coef
     @@:
       lodsb
       cmp   al,1
       jz    @f
       stosb
       jmp   @b
     @@:
       pop   ecx
       inc   ecx
       cmp   ecx,.pccv	;[points_count_var]
       jnz   .again_vertex
       mov   esi,asc_face_list_header
      @@:
	lodsb
	cmp   al,1	; all face header
	jz    @f
	stosb
	jmp   @b
      @@:
	   ;=====================================
	   ; ==============face list parser======
	   ;=====================================
       xor   ecx,ecx
     .again_face:
       push  ecx
       mov   .counter,ecx
       mov   esi,asc_one_face_formula
     @@:
       lodsb
       cmp   al,1
       jz    @f
       stosb
       jmp   @b
     @@:
       mov   eax,ecx
       push  esi
       mov   esi,edi
       call  itoa
       pop   esi
       inc   esi
     @@:
       lodsb
       cmp   al,1
       jz    @f
       stosb
       jmp   @b
     @@:
	xor    ebx,ebx
     .next_face_index:
	push   ebx
	mov    ecx,.counter
	lea    ecx,[ecx*3]
	shl    ecx,2
	mov    eax,[triangles_ptr]
	add    eax,ecx
	mov    eax,dword[eax+ebx]
	push   esi
	mov    esi,edi
	call   itoa
	pop    esi
       @@:
	lodsb
	cmp    al,1
	jz     @f
	stosb
	jmp    @b
      @@:
	pop	ebx
	add	ebx,4
	cmp	ebx,12
	jnz	.next_face_index
	pop	ecx
	inc	ecx
	cmp	ecx,.tccv   ;[triangles_count_var]
	jnz    .again_face
	  ; write file
	sub	edi,.file_buff
	mov	ecx,edi
	mov	eax,asc_file_name
	mov	edx,.file_buff
	call	save_fileA
	mfree	.file_buff
	mov	esp,ebp
	pop	ebp
ret

